
# Define the bucket for backups 
filebucket { main: 
	server => "myops.planet-lab.org" 
}

# And, specify it as the default target
File { backup => main }

class planetlab_node {
	file { "/tmp/puppet_setup_blue":
	    ensure => present,
		mode => 644,
		owner => root,
		group => root,
	}

	file { "/etc/planetlab/plc_config":
	    ensure => present,
		mode => 644,
		backup => main,
	}

	file { "/usr/bin/cleanrpm.sh":
		source => "puppet:///sample/cleanrpm.sh",
	    ensure => present,
		mode => 755,
	}

	exec { "/usr/bin/cleanrpm.sh":
		onlyif => "test `pgrep \"rpm|yum\" | wc -l` -gt 0",
	    creates => "/tmp/cleanrpm.log",
		path => ["/bin", "/usr/bin", "/usr/sbin"],
	}
}

class puppet_config {

	package { 'ruby-rdoc':
	    ensure => installed,
	}

	file { "/etc/puppet/puppet.conf":
		source => "puppet:///sample/puppet.conf",
	    ensure => present,
		mode => 644,
	}
}


