#!/bin/bash

if [ -f /etc/planetlab/plc_config ]; then
	source /etc/planetlab/plc_config
else
	PLC_SLICE_PREFIX='pl'
fi

IP=IPADDR
DIR=PlanetLabConf
FILE=bootstrap.tar.gz
HDIR=/home/${PLC_SLICE_PREFIX}_myops

mkdir -p $HDIR
cd $HDIR

# before update
if [ -f $FILE ] ; then
    mod_time_before=`stat -c %Y $FILE`
    CURL_ARGS="-z $FILE"
else
    mod_time_before=0
    CURL_ARGS=""
fi

if [ -f /usr/boot/myops_cacert.pem ] ; then
	CURL_ARGS="$CURL_ARGS --cacert /usr/boot/myops_cacert.pem"
else
	CURL_ARGS="$CURL_ARGS --insecure"
fi

# if bootstrap file has been updated
curl $CURL_ARGS -s -O https://$IP/$DIR/$FILE

if [ -f $FILE ] ; then
    mod_time_after=`stat -c %Y $FILE`
else
    mod_time_after=0
fi

if [[ $mod_time_after -gt $mod_time_before ]] ; then
    # then an update occurred, and we need to unpack it.   
    tar -xzf $FILE
    chmod 755 ./*.sh ./*.py
    ./bootstrap.sh || exit 1
    touch $HDIR/update_ok
fi

