#!/bin/bash

if [ -f /etc/planetlab/plc_config ]; then
	source /etc/planetlab/plc_config
else
	PLC_SLICE_PREFIX='pl'
fi
if [ -f /usr/boot/myops_cacert.pem ] ; then
	CURL_ARGS="$CURL_ARGS --cacert /usr/boot/myops_cacert.pem"
else
	CURL_ARGS="$CURL_ARGS --insecure"
fi

export MYOPS_SERVER=IPADDR

function upload_log ()
{
    file=$1
    path=$2
    base=$( basename $file )
    old=/tmp/${base}.old
    new=/tmp/${base}.new
    log=/tmp/${base}.log
    if [ ! -f $file ] ; then
        return
    fi
    if [ -f $new ] ; then
        cp $new $old
    else
        touch $old
    fi
    cp $file $new
    #comm -1 -3 $old $new > $log
    cp $new $log
    if [ $( stat -c %s $log ) -ne 0 ] ; then
        curl $CURL_ARGS --max-time 60 --silent https://${MYOPS_SERVER}/upload.php --form "namespace=${PLC_SLICE_PREFIX}" --form "log=@$log"
        if [ $? -ne 0 ] ; then
            # the upload has failed, so remove new file so no data is lost
            rm -f /tmp/$( basename $file ).new
        fi
    fi
}

function upload_logs ()
{
    upload_log $1 multiops
}

upload_logs /home/${PLC_SLICE_PREFIX}_myops/myops.log

