#!/bin/bash

if [ -z "$1" ] ; then
    ns="raw"
else
    ns="$1"
fi
if [ -z "$2" ] ; then
	DATE=$( date --date "1 hour ago" +%Y-%m-%dT%H )
else
	DATE="$2"
fi
PREFIX=/var/www/html/uploadlogs/$ns/old

# get keys
key_list="uptime free_disk_root free_disk_vservers fprobe_size"
extra="
"

# get count of unique values from keys
echo $START Hours ago == $DATE
c=`ls $PREFIX/$DATE/*--upload | wc -l`
if [[ $c -gt 2 ]] ; then
    for val in $key_list ; do 
        echo $val
        c=`grep -E -h "^$val :" $PREFIX/$DATE/*--upload | wc -l`
		if [[ $c -gt 2 ]] ; then
		    grep -h -E "^$val :" $PREFIX/$DATE/*--upload | \
				awk '{print $3}' | sort -n | \
				/usr/share/myops/web/collect/server/stats.py | \
				while read value_name value ; do 
					/usr/share/myops/web/collect/server/load-graphite.py --target "myops.$ns.stats.$val.$value_name" --date $DATE  --value $value
					sleep .2
				done
		fi
    done
fi

